/* Copyright (C) 1994 Queen Mary and Westfield College, University of London

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   A copy of the GNU General Public License may be found in
   doc/COPYING in the source tree of this programm.

   This file was written by: Franz Gerschwiler.(goblin@dcs.qmw.ac.uk)

 ****

   modified by: p.hlstede	(peter@calvados.chemie.uni-bremen.de)

   - the code was reorganized and ansified
   - the limitation of the text to a maximum size was cancelled
   - text changes are inserted into the undo stack (from asedit)

							06.09.1997
 */

#include <X11/cursorfont.h>
#include <Xm/Xm.h>
#include <Xm/Text.h>

#include "sys_consts.h"
#include "globals.h"
#include "utils.h"
#include "callbacks.h"
#include "undo.h"


/***  GLOBAL VARIABLES  ***/
int   changes_counter;


void  gui_keypressCB(Widget w, XtPointer client_data, XtPointer call_data)
{
#ifdef NO_LARGE_FILES
   XmTextVerifyCallbackStruct *cbd = (XmTextVerifyCallbackStruct *) call_data;

   /* Deal with very large documents */
   if ((XmTextGetLastPosition(text_canvas) + cbd->text->length) > MAX_DOCUMENT_LENGTH)
   {
      if (gui_error("Warning you have exceeded the maximum length for a document\nText entry ignored.\nDo not continue to enter code or a crash could occur.") == HELP)
	 gui_info("This is a bug I haven't managed to iron out yet sorry");
      cbd->doit = False;
   }
   else
   {
#endif
      if (!undo_redo_action)
	 SaveActionForUndo(w, client_data, call_data);
      undo_redo_action = False;

      if ((changes_counter == 0) || (changes_counter == 1))
	 set_title_string();
#ifdef NO_LARGE_FILES
   }
#endif
}
